package no.ntnu.idatt1002.demo.data.Economics;

import java.util.List;

/**
 * ExpenseRegister is a class for
 * storing Expenses. Subclass of
 * ItemRegister.
 */
public class ExpenseRegister extends ItemRegister<Expense> {

    /**
     * Class constructor that creates an empty List for storing Expense.
     */
    public ExpenseRegister() {
        super();
    }

    /**
     * Class constructor that takes in a List of Expense as argument.
     *
     * @param expenses the List of Expense you want to register.
     */
    public ExpenseRegister(List<Expense> expenses){
        super(expenses);
    }

    /**
     * Method for getting every Expense
     * in a given ExpenseCategory.
     *
     * @param category the ExpenseCategory you want to get every Expense of.
     * @return a List of every Expense with category.
     */
    public List<Expense> getExpenseByCategory(ExpenseCategory category){
        return this.items.stream().filter(expense -> expense.getCategory().compareTo( category) == 0).toList();
    }
}
