package no.ntnu.idatt1002.demo.data.Budget;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class FoodBudgetTest {

    @Test
    void set_amount_budget() {
        FoodBudget foodBudget = new FoodBudget(30, 0);
        int amount = 2000;
        foodBudget.setAmountBudget(amount);

        assertEquals(amount, foodBudget.getBudgetAmount());
    }

    @Test
    void set_amount_budget_negativ_amount() {
        FoodBudget foodBudget = new FoodBudget(30, 0);
        int amount = -2000;

        assertThrows(IllegalArgumentException.class, () -> foodBudget.setAmountBudget(amount));
    }

    @Test
    void set_budget_period() {
        FoodBudget foodBudget = new FoodBudget(0, 30);
        int period = 30;
        foodBudget.setBudgetPeriod(period);

        assertEquals(period,foodBudget.getBudgetPeriod());
    }

    @Test
    void set_budget_period_negative_period() {
        FoodBudget foodBudget = new FoodBudget(0, 30);
        int period = -5;

        assertThrows(IllegalArgumentException.class, () ->  foodBudget.setBudgetPeriod(period));
    }

    @Test
    void add_to_budget_positive_number() {
        FoodBudget foodBudget = new FoodBudget(0, 30);
        int beforeAdding = foodBudget.getBudgetAmount();
        int amountToBeAdded = 50;
        foodBudget.addToBudget(amountToBeAdded);

        assertEquals(beforeAdding + amountToBeAdded, foodBudget.getBudgetAmount());

    }

    @Test
    void add_to_budget_negative_number() {
        FoodBudget foodBudget = new FoodBudget(0, 30);
        int amountToBeAdded = -7;

        assertThrows(IllegalArgumentException.class, () -> foodBudget.addToBudget(amountToBeAdded));
    }

    @Test
    void subtract_from_budget_positive_number() {
        FoodBudget foodBudget = new FoodBudget(0, 30);
        int beforeSubtracting = foodBudget.getBudgetAmount();
        int amountToBeSubtracted = 50;
        foodBudget.subtractFromBudget(amountToBeSubtracted);

        assertEquals(beforeSubtracting - amountToBeSubtracted, foodBudget.getBudgetAmount());
    }

    @Test
    void subtract_from_budget_negative_number() {
        FoodBudget foodBudget = new FoodBudget(0, 30);
        int amountToBeSubtracted = -7;

        assertThrows(IllegalArgumentException.class, () -> foodBudget.subtractFromBudget(amountToBeSubtracted));
    }

    @Test
    void getDaysLeftOfBudgetPeriod(){

    }

}